using System;
using System.Collections;
using System.ComponentModel;
using System.Configuration;
using System.Data;
using System.Data.SqlClient;
using System.Drawing;
using System.IO;
using System.Web;
using System.Web.SessionState;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.HtmlControls;

namespace RedPlus.Notice
{
	/// <summary>
	/// RedPlus.Notice.List : ϼ(Notice) Խ Ʈ 
	/// </summary>
	public class List : System.Web.UI.Page
	{
		#region Controls
		protected System.Web.UI.WebControls.DataGrid DataGrid1;
		protected System.Web.UI.WebControls.Button btnWrite;
		protected System.Web.UI.WebControls.TextBox SearchQuery;
		protected System.Web.UI.WebControls.DropDownList SearchField;
		protected System.Web.UI.WebControls.Button btnSearch;
		protected System.Web.UI.WebControls.RequiredFieldValidator RequiredFieldValidator1;
		protected System.Web.UI.WebControls.ValidationSummary ValidationSummary1;	
		#endregion
	
		#region Private/Protected/Public Member Variables
		public int intPage = 0;
		protected RedPlus.Paging.RedPlusPaging RedPlusPaging1;
		public int intTotalCount = 0;// ڵ (۹ȣ  Ŀ)
		#endregion

		#region Event Handlers
		private void Page_Load(object sender, System.EventArgs e)
		{
			//Ű  Ʈ  ȣ  
			if(Request.Cookies["Notice"] != null)
			{
				string strPageNum = Request.Cookies["Notice"]["PageNum"].ToString();
				if(strPageNum != null)
				{
					intPage = Convert.ToInt32(strPageNum);
				}
				else
				{
					intPage = 0;
				}
				//DataGrid1.CurrentPageIndex = intPage;
				this.RedPlusPaging1.CurrentPageIndex = intPage;
			}

			intTotalCount = GetTotalRecordCount();//Notice̺   
			
			if(!Page.IsPostBack)
			{
				//DataGrid1.PageSize = 10;
				//DataGrid1.VirtualItemCount = intTotalCount;
				this.RedPlusPaging1.PageSize = 10;
				this.RedPlusPaging1.VirtualItemCount = intTotalCount;
				ReadData();
			}
		}


		#region ͱ׸ Ʈ ٿ   ֱ  ̹ ǥ  콺  ȿ
		private void DataGrid1_ItemDataBound(object sender, System.Web.UI.WebControls.DataGridItemEventArgs e)
		{
			#region 24ð ö  new ̹ ǥϱ
			if(e.Item.ItemType == ListItemType.Item || e.Item.ItemType == ListItemType.AlternatingItem)
			{
				string strDate = ((DataRowView)e.Item.DataItem)["PostDate"].ToString();
				DateTime originDate = Convert.ToDateTime(strDate);

				TimeSpan objTs = DateTime.Now - originDate;
				if(objTs.TotalMinutes < 1440)
				{
					Literal l = new Literal();
					l.Text = "<img src=images/lastest.gif>";
					e.Item.Cells[2].Controls.Add(l);
				}
			}
			#endregion

			#region 콺  ϰ ϴ ...
			if( e.Item.ItemType == ListItemType.Item)
			{
				e.Item.Attributes["onMouseOver"] ="this.style.backgroundColor ='#FFE9BB'"; 
				e.Item.Attributes["onMouseOut"] = "this.style.backgroundColor='White'";  
			}
			else if(e.Item.ItemType == ListItemType.AlternatingItem )
			{
				e.Item.Attributes["onMouseOver"] ="this.style.backgroundColor ='#FFE9BB'"; 
				e.Item.Attributes["onMouseOut"] = "this.style.backgroundColor='F1F0FB'";  
			}
			#endregion            
		}
		#endregion		

		#region  ȣ ٲ ó
		private void RedPlusPaging1_PageIndexChanged(object sender, RedPlus.Paging.PageIndexChangedEventArgs e)
		{
			intPage = e.NewPageIndex;
			this.RedPlusPaging1.CurrentPageIndex = e.NewPageIndex;
			Response.Cookies["Notice"]["PageNum"] = intPage.ToString();// ȣ 
			ReadData();			
		}
		#endregion
		
		#region ۾ ư ũ
		private void btnWrite_Click(object sender, System.EventArgs e)
		{
			Response.Redirect("./Write.aspx");
		}
		#endregion

		#region ͱ׸ Ʈ ¡ ó
		private void DataGrid1_PageIndexChanged(object source, System.Web.UI.WebControls.DataGridPageChangedEventArgs e)
		{
			intPage = e.NewPageIndex;
			DataGrid1.CurrentPageIndex = e.NewPageIndex;
			Response.Cookies["Notice"]["PageNum"] = intPage.ToString();// ȣ 
			ReadData();
		}
		#endregion

		#region ˻ ó ũ
		private void btnSearch_Click(object sender, System.EventArgs e)
		{
			string strQuery = 
				String.Format(
				"./Search.aspx?SearchField={0}&SearchQuery={1}", 
				SearchField.SelectedItem.Value,
				SearchQuery.Text
				);
			Response.Redirect(strQuery);
		}
		#endregion
		#endregion

		#region Public Methods
		#region »  ̵ ũ
		public string funcLink(object objNum)
		{
			return String.Format("View.aspx?Num={0}", objNum.ToString());
		}
		#endregion

		#region  Խ ̺ ڵ  ȯϴ ޼ GetTotalRecordCount()
		private int GetTotalRecordCount()
		{
			SqlConnection objCon = new SqlConnection();
			objCon.ConnectionString = System.Configuration.ConfigurationSettings.AppSettings["ConnectionString"];
			objCon.Open();

			SqlCommand objCmd = new SqlCommand();
			objCmd.Connection = objCon;
			objCmd.CommandText = "procGetCountNotice";
			objCmd.CommandType = CommandType.StoredProcedure;
			int totalCount = (int)objCmd.ExecuteScalar();
			objCon.Close();

			return totalCount;
		}
		#endregion

		#region   Step 鿩 ó
		public string funcStep(object objStep)
		{
			int intStep = Convert.ToInt32(objStep);
			string strTemp = String.Empty;
			if(intStep == 0)
			{
				strTemp = String.Empty;
			}
			else
			{
				for(int i=0;i < intStep;i++)
				{
					strTemp = 
						String.Format(
						"<img src={0} height={1} width={2}>",
						"images/blank.gif", 
						"0",
						(intStep * 15)
						);
				}
				strTemp += "<img src='images/re.gif'>";
			}
			return strTemp;
		}
		#endregion

		#region   ڸ
		public static string funcCutString(object strTitle, int intMax)
		{
			return RedPlus.Library.Board.CutString(strTitle.ToString(), intMax);
		}
		#endregion

		#region  ٿε 
		public string funcFileDown(int intNum, string strFileName, string strFileSize)
		{
			if(strFileName.Length > 0)
			{
				//return "<a href='Down.aspx?Num=" + intNum.ToString() + "'>" + NoticeFunction.DownloadType(strFileName, strFileName + "(" + NoticeFunction.ConvertToFileSize(Convert.ToInt32(strFileSize)) + ")") + "</a>";
				return "<a href='Down.aspx?Num=" + intNum.ToString() + "'>" + RedPlus.Library.Board.DownloadType(strFileName, strFileName + "(" + RedPlus.Library.Board.ConvertToFileSize(Convert.ToInt32(strFileSize)) + ")") + "</a>";
			}
			else
			{
				return "-";
			}
		}
		#endregion

		#region ڸƮ  ǥ
		public string funcCommentNum(object objCommentNum)
		{
			string strTemp = String.Empty;
			try
			{
				if(Convert.ToInt32(objCommentNum.ToString()) > 0)
				{
					strTemp = "<img src='images/commentcount.gif' border='0'>";
					strTemp += "(" + objCommentNum.ToString() + ")";
				}
				else
				{
					strTemp = String.Empty;
				}
			}
			catch
			{
				strTemp = String.Empty;
			}
			return strTemp;
		}
		#endregion

		#region   شϴ  о ͱ׸忡 ϴ Լ
		private void ReadData()
		{
			SqlConnection objCon = new SqlConnection();
			objCon.ConnectionString = System.Configuration.ConfigurationSettings.AppSettings["ConnectionString"];
			objCon.Open();

			SqlCommand objCmd = new SqlCommand();
			objCmd.Connection = objCon;
			objCmd.CommandText = "procListNoticeAdvancedPaging";//¡
			objCmd.Parameters.Add("@PageSize", SqlDbType.Int);
			objCmd.Parameters.Add("@IntPage", SqlDbType.Int);
			objCmd.Parameters["@PageSize"].Value = 10;//10 
			objCmd.Parameters["@intPage"].Value = intPage;//
			objCmd.CommandType = CommandType.StoredProcedure;
			
			SqlDataAdapter objDa = new SqlDataAdapter();
			objDa.SelectCommand = objCmd;

			DataSet objDs = new DataSet();
            
			objDa.Fill(objDs, "Notice");
            
			//intTotalCount = objDs.Tables["Notice"].Rows.Count;
			DataGrid1.DataSource = objDs.Tables["Notice"].DefaultView;
			DataGrid1.DataBind();
		}

		#endregion
		#endregion

		#region Web Form Designer generated code
		override protected void OnInit(EventArgs e)
		{
			//
			// CODEGEN:  ȣ ASP.NET Web Form ̳ʿ ʿմϴ.
			//
			InitializeComponent();
			base.OnInit(e);
		}
		
		/// <summary>
		/// ̳  ʿ ޼Դϴ.
		///  ޼  ڵ   ʽÿ.
		/// </summary>
		private void InitializeComponent()
		{    
			this.DataGrid1.PageIndexChanged += new System.Web.UI.WebControls.DataGridPageChangedEventHandler(this.DataGrid1_PageIndexChanged);
			this.DataGrid1.ItemDataBound += new System.Web.UI.WebControls.DataGridItemEventHandler(this.DataGrid1_ItemDataBound);
			this.RedPlusPaging1.PageIndexChanged += new RedPlus.Paging.PageIndexChangedEventHandler(this.RedPlusPaging1_PageIndexChanged);
			this.btnWrite.Click += new System.EventHandler(this.btnWrite_Click);
			this.btnSearch.Click += new System.EventHandler(this.btnSearch_Click);
			this.Load += new System.EventHandler(this.Page_Load);

		}
		#endregion
	}
}